// test.c
#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include <cstdio>
#include "adxl345/adxl345.h"
#include "lcd.h"

//string buffer for printing on the LCD
char stepsBuff[16];
//counter of possibly valid steps
unsigned short possibleSteps;
//valid steps
static int steps;
// the three axes of accelerometer
double ax, ay, az;

/*
	function to display the number of steps
*/
void print()
{	
	LCD_printAt(0, "Number of steps:");
	if (steps == 1)
		sprintf(stepsBuff,"%d.", steps);
	else
		sprintf(stepsBuff,"%d.", steps);
	//print centered on the first row of the LCD
	LCD_printAt(42, stepsBuff);
	
}

/*
	function that gets data from accelerometer
	and computes number of steps
*/

void execute()
{
	while(1) {
		if(ax == 0) {
			LCD_print("Take some steps!");
		}
		adxl345_getdata(&ax, &ay, &az);
		if(ax > 0)
			possibleSteps++;
		if (possibleSteps > 0 && possibleSteps < 10)
			steps += (possibleSteps % 2);
		print();
	}
}

int main()
{
    
    	steps = 0;
	possibleSteps = 0;
	// check using ... led
    	DDRD |= (1 << PD7);
	//button BTN - set PD6 as input
	DDRD &= ~(1 << PD6);
	// buzzer
	DDRD |= (1<<PD5);
    	LCD_init();
	adxl345_init();
	execute();
	if(steps >= 1000){
			PORTD &= ~(1<<PD5);
	} 
    	while(1) {
        	PORTD ^= (1 << PD7);
        	_delay_ms(500);
		
		// if BTN is pressed
		 if ((PIND & (1 << PD6)) == 0){
			_delay_ms(500);
			// reset pedometer
			if ((PIND & (1 << PD6)) == 0){
				LCD_print("Take some steps!");
				steps = 0;
				possibleSteps = 0;
			}
		}
    	}
}
